<template>
  <div>
    <v-card class="pl-6 pr-6 pb-5 pt-2">
      <v-card-title class="pb-0">
        <h1>
          <b v-if="usuario">{{$t('editarUsuario')}}</b>
          <b v-else>{{$t('nuevoUsuario')}}</b>
        </h1>
      </v-card-title>
      <v-form v-model="valid" ref="usuarioFrom" class="pb-4 pt-4">
        <v-row>
          <v-col cols="12" lg="6" md="6" sm="12">
            <v-text-field
              v-model="form.name"
              :rules="rules.isRequiredyNoSim"
              maxlength="50"
              :counter="50"
              :label="$t('nombre')"
              dense
              @input="nonumeros"
            />
          </v-col>
          <v-col cols="12" lg="6" md="6" sm="12">
            <v-text-field
              v-model="form.email"
              dense
              :label="$t('correoElectronico')"
              :rules="rules.emailRules"
              @keyup="lowercase"
            />
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12" lg="4" md="4" sm="12">
            <v-select
              v-model="form.area"
              :items="areas"
              :rules="rules.isRequired"
              :label="$t('area')"
              dense
            ></v-select>
          </v-col>
          <v-col cols="12" lg="4" md="4" sm="12">
            <v-select
              v-model="form.tipo"
              :items="tipos"
              :rules="rules.isRequired"
              :label="$t('tipo')"
              dense
            ></v-select>
          </v-col>
          <v-col cols="12" lg="4" md="4" sm="12">
            <v-text-field
              v-model="form.password"
              dense
              :rules="rules.isRequired"
              :label="$t('password')"
              type="password"
            />
          </v-col>
        </v-row>
      </v-form>
      <v-card-actions>
        <v-row>
          <v-btn
            color="accent"
            rounded
            @click="guardarUsuario"
          >
            {{$t('guardar')}}
          </v-btn>
          <v-btn text color="error" rounded @click="cancelarGuardar">
            {{$t('cancelar')}}
          </v-btn>
          <br/>
        </v-row>
      </v-card-actions>
    </v-card>
  </div>
</template>

<script>
import UsuarioServicio from '@/store/services/UsuarioServicio'

export default {
  name:'UsuariosForm',
  props: {
    usuario: {
      type: Object,
      required: false,
      default: null,
    }
  },
  data () {
    return {
      valid: false,
      form: {
        id: null,
        name: '',
        email: '',
        area: '',
        tipo: '',
        password: ''
      },
      rules: {
        isRequired: [
          value => !!value || this.$t('campoRequerido'),
        ],
        emailRules: [
          v => !!v || this.$t('campoRequerido'),
          v => /.+@.+\..+/.test(v) || this.$t('correoDebeSerRequerido'),
        ],
        cmax: [
        value => (value && value.length < 50) || this.$t('cantidadErronea'),
        ],

        isRequiredyNoSim: [
          value => !!value || this.$t('campoRequerido'),
          v => /[^0-9+\W]/g.test(v) || this.$t('noNumerosC'),
        ],
      },
      isLoading: false,
      areas: [
        'Presidente',
        'Vicepresidente',
        'Vocal I',
        'Vocal II',
        'Comisión de Constitución, Desarrollo Legislativo, Sistema Electoral y Justicia Plural',
        'Comisión de Planificación, Política Económica y Finanzas Públicas',
        'Comisión de Infraestructura y Obras Públicas del Desarrollo',
        'Comisión de Minería, Hidrocarburos, Recursos Naturales, Producción, Industria, Comercio y Servicios',
        'Comisión de Autonomía, Organización Territorial y Límites',
        'Comisión de Relaciones Intergubernamentales e Internacionales',
        'Comisión de Educación, Salud, Derechos Humanos y Política Social',
        'Comisión de Medio Ambiente, Desarrollo Rural Integral Sustentable y Soberanía Alimentaria',
        'Oficial Mayor',
        'Jefe Unidad Administrativa y Financiera',
        'Encargado Área de Contratación, Provisión y D. Bs. y Ss.',
        'Encargado Área Contabilidad',
        'Profesional Técnico - Presupuestos',
        'Profesional I-Sistemas informáticos Activos Fijos y almacenes',
        'Profesional I - Comunicador Social',
        'Secretaria Ejecutiva II - Comisiones',
        'Secretaria Ejecutiva II - Directiva',
        'Ujier Administrativo',
        'Chofer Profesional I - Directiva',
        'Chofer Profesional II - Comisiones',
      ],
      tipos: [
        'ADMIN',
        'JEFATURA',
        'SOLICITANTE',
        'COMPRADOR',
        'ALMACEN',
      ]
    }
  },
  methods: {
    async guardarUsuario() {
      try {
        if (this.$refs.usuarioFrom.validate()) {
          var response = ''
          if (!this.form.id || this.form.id === '') {
            let dataForm = new FormData()
            for (let key in this.form) {
              dataForm.append(key, this.form[key])
            }
            response = await UsuarioServicio.create(dataForm)
          } else {
            response = await UsuarioServicio.update(this.form.id, this.form)
          }
          this.resetData()
          this.$emit('onUsuarioGuardado', response.data)
        }
      } catch (e) {console.log(e)
        if (e.response.status > 300) {
          console.log(e.response)
        }
      }
    },
    cancelarGuardar() {
      this.resetData()
      this.$emit('onCancelarGuardar',  false);
    },
    uppercase() {
        this.form.name = this.form.name.toUpperCase();
    },

    lowercase() {
        this.form.email = this.form.email.toLowerCase();
    },


    nonumeros() {
      //this will replace every non letter input with an empty string leading to removing it
      this.form.name = this.form.name.replaceAll(/[^a-zA-Z-( )]/g, "");
      //you can also do your uppercase change here, no need to do it in update
      //this.form.name = this.form.name.toUpperCase()
    },

    setData() {
      if (this.usuario) {
        this.form.id = this.usuario.id
        this.form.name = this.usuario.name
        this.form.email = this.usuario.email
        this.form.area = this.usuario.area
        this.form.tipo = this.usuario.tipo
        this.form.password = this.usuario.password
      }
    },
    resetData() {
      this.form.id = null
      this.form.name = ''
      this.form.email = ''
      this.form.area = ''
      this.form.tipo = ''
      this.form.password = ''
    }
  },
  computed: {

  },
  watch: {
    usuario: {
      immediate: true,
      handler() {
        this.resetData()
        this.setData()
      }
    }
  },
  created() {
    this.setData()
  }
}
</script>

<style>

</style>
